package com.huimv.production.autoGetData.service.impl;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
//import com.huimv.common.date.DateUtil;
import com.huimv.production.autoGetData.entity.IndexParameter;
import com.huimv.production.autoGetData.entity.ProductionGroup;
import com.huimv.production.autoGetData.repo.IndexParameterRepository;
import com.huimv.production.autoGetData.repo.ProductionGroupRepo;
import com.huimv.production.autoGetData.service.IAutoGetErpData;
import com.huimv.production.autoGetData.utils.HttpClientUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class AutoGetErpDataImpl implements IAutoGetErpData {
    // 查询开始日期
//    @Value("${erp.datasource.startDate}")
//    private String startDate;
    // 查询结束日期
//    @Value("${erp.datasource.endDate}")
//    private String endDate;
    @Value("${erp.datasource.apiIp}")
    private String apiIp;
    @Value("${erp.datasource.apiPort}")
    private String apiPort;
    @Value("${erp.datasource.serviceName}")
    private String serviceName;
    @Autowired
    private HttpClientUtil httpClientUtil;
    @Autowired
    private RestTemplate template;
    @Autowired
    private IndexParameterRepository parameterRepository;
    @Autowired
    private ProductionGroupRepo productionGroupRepo;
    @Autowired
    private com.huimv.production.autoGetData.utils.DateUtil dateUtil;

    //PSY
    @Override
    public void getPsy() {
        String token = getToken();
//        String servicePath = apiIp + apiPort + serviceName;
//        System.out.println("servicePath>>"+servicePath);
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
          endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getPsy?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }
        IndexParameter indexParameter = parameterRepository.findById(7).get();
        indexParameter.setUpdateTime(new Date());
        indexParameter.setData(data);
        System.out.println("PSY------->"+data);

        parameterRepository.save(indexParameter);



        System.out.println("startDate:"+startDate);
        System.out.println("endDate:"+endDate);
    }

    //返情率
    @Override
    public void getReEstrusRate() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
          endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getReEstrusRate?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }

        String reestrus_rate ="0.00000";
        String variety = "";
        ProductionGroup productionGroup = new ProductionGroup();
        int i =4;
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
//            for (String s : stringStringMap.keySet()) {
//                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    reestrus_rate  = stringStringMap.get("reestrus_rate");
                    variety = stringStringMap.get("variety");
                    productionGroup.setProductionType("reEstrus");
                    productionGroup.setVariety(variety);
                    productionGroup.setId(i);
                    productionGroup.setFrequency(reestrus_rate);
                    productionGroupRepo.save(productionGroup);
                    i++;
//                }
//            }
        }
        System.out.println("返情率------->"+data);


    }

    //获取分娩率
    @Override
    public void getParturitionRate() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
          endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getParturitionRate?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }

        String parturitionRate ="0.00000";
        String variety = "";
        ProductionGroup productionGroup = new ProductionGroup();
        int i =1;
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
//            for (String s : stringStringMap.keySet()) {
//                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    parturitionRate  = stringStringMap.get("parturition_rate");
                    variety = stringStringMap.get("variety");
                    productionGroup.setFrequency(parturitionRate);
                    productionGroup.setId(i);
                    productionGroup.setProductionType("parturition");
                    productionGroup.setVariety(variety);
                    productionGroupRepo.save(productionGroup);
                    i++;
//                }
//            }
        }

        System.out.println("分娩率--->"+data);

    }

    //获取各种存栏
    @Override
    public List getStorage() {


        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getStorage?accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return null;
        }
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);JSON.parse(data);
        List list1 = new ArrayList();
        for (Map<String, String> stringStringMap : list) {
            for (String s : stringStringMap.keySet()) {
                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    Map map = new HashMap();
                    map.put("name",stringStringMap.get("name"));
                    map.put("quantity",stringStringMap.get("quantity"));
                    list1.add(map);
//                }
            }
        }
        System.out.println("各种存栏--->"+data);
        return list1;
    }

    //获取均产仔数，仔猪存活率
    @Override
    public void getPigletInfo() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
        endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getPigletInfo?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }
        //TODO 未完成
        System.out.println("均产仔数，仔猪存活率--->"+data);
        String birth_number ="0";
        String total ="0";
        String dead_quantity ="0";
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
            for (String s : stringStringMap.keySet()) {
                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    birth_number  = stringStringMap.get("birth_number");
                    total  = stringStringMap.get("total");
                    dead_quantity  = stringStringMap.get("dead_quantity");
//                }
            }
        }

        //分娩头数
        IndexParameter indexParameter = parameterRepository.findById(19).get();
        indexParameter.setData(birth_number);
        indexParameter.setUpdateTime(new Date());
        parameterRepository.save(indexParameter);
        System.out.println(indexParameter);


        //产仔总数
        IndexParameter indexParameter2 = parameterRepository.findById(20).get();
        indexParameter2.setData(total);
        indexParameter2.setUpdateTime(new Date());
        parameterRepository.save(indexParameter2);

        //仔猪死淘数
        IndexParameter indexParameter3 = parameterRepository.findById(21).get();
        indexParameter3.setData(dead_quantity);
        indexParameter3.setUpdateTime(new Date());
        parameterRepository.save(indexParameter);
    }

    //配种数量
    @Override
    public void getMateQuantity() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
        endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getMateQuantity?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }
        String mate_quantity ="0";
        String variety = "";
        ProductionGroup productionGroup = new ProductionGroup();
        int i = 7;
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
//            for (String s : stringStringMap.keySet()) {
//                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    mate_quantity  = stringStringMap.get("mate_quantity");
                    variety = stringStringMap.get("variety");
                    productionGroup.setId(i);
                    productionGroup.setFrequency(mate_quantity);
                    productionGroup.setVariety(variety);
                    productionGroup.setProductionType("mateQuantity");
                    productionGroupRepo.save(productionGroup);
                    i++;
//                }
//            }
        }

        System.out.println("配种数------->"+data);


    }

    //受胎率
    @Override
    public void getConceptionRate() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
          endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getConceptionRate?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }
        String conception_rate ="0";
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
//            for (String s : stringStringMap.keySet()) {
//                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    conception_rate  = stringStringMap.get("conception_rate");
//                }
//            }
        }
        IndexParameter indexParameter = parameterRepository.findById(18).get();
        indexParameter.setData(conception_rate);
        indexParameter.setUpdateTime(new Date());

        System.out.println("受胎率------->"+data);
        parameterRepository.save(indexParameter);
    }
    //总存栏，母猪存栏
    @Override
    public void getAllStorage() {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
          endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);

        String token = getToken();
        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getAllStorage?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        if (data == null){
            return;
        }
        List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        String total ="0";
        String sow_quantity="0";

        for (Map<String, String> stringStringMap : list) {
            for (String s : stringStringMap.keySet()) {
                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    total = stringStringMap.get("total");
                    sow_quantity = stringStringMap.get("sow_quantity");
//                }
            }
        }
        IndexParameter indexParameter = parameterRepository.findById(2).get();
        indexParameter.setData(total);
        indexParameter.setUpdateTime(new Date());
        parameterRepository.save(indexParameter);

        IndexParameter indexParameter1 = parameterRepository.findById(3).get();
        indexParameter1.setData(sow_quantity);
        indexParameter1.setUpdateTime(new Date());
        System.out.println("总存栏，母猪存栏------->"+data);

        parameterRepository.save(indexParameter);
    }

    @Override
    public List findAll() {
        List<ProductionGroup> delivery = productionGroupRepo.findAllByVariety("巴嘉");
        List<ProductionGroup> reservice = productionGroupRepo.findAllByVariety("杜巴嘉");
        List<ProductionGroup> breeding = productionGroupRepo.findAllByVariety("金华两头乌");
        Map map1 = new HashMap();
        Map map2 = new HashMap();
        Map map3 = new HashMap();
        map1.put("veriety","巴嘉");
        map2.put("veriety","杜巴嘉");
        map3.put("veriety","金华两头乌");
        for (ProductionGroup productionGroup : delivery) {
            map1.put(productionGroup.getProductionType(),productionGroup.getFrequency());
        }
        for (ProductionGroup productionGroup : reservice) {
            map2.put(productionGroup.getProductionType(),productionGroup.getFrequency());
        }
        for (ProductionGroup productionGroup : breeding) {
            map3.put(productionGroup.getProductionType(),productionGroup.getFrequency());
        }

        List list = new ArrayList();
        list.add(map1);
        list.add(map2);
        list.add(map3);
        return list;
    }

    @Override
    public void getManyFarmProduce() throws IOException {
        String startDate ;
        String endDate;
        DateTime date = DateUtil.date();
        endDate = (date+"").substring(0,10);
        startDate =  (DateUtil.beginOfMonth(date)+"").substring(0,10);
        //
        String token = getRemoteToken();
//        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getManyFarmProduce?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
//                ,JSONObject.class );
//        String data = jsonObject.getString("data");
//        if (data == null){
//            return;
//        }
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("startDate", startDate);
        paramsMap.put("endDate", endDate);
        paramsMap.put("accessToken", token);

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 120000);
        timeoutMap.put("requestTimeout", 120000);
        timeoutMap.put("socketTimeout", 120000);
        String url = apiIp + apiPort + serviceName +"/getManyFarmProduce";
        System.out.println("url="+url);
        System.out.println("paramsMap="+paramsMap.toString());
        System.out.println("timeoutMap="+timeoutMap.toString());
        System.out.println("开始取数＝"+new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.get(url,paramsMap,timeoutMap);
        System.out.println("返回结果="+outJo);
        System.out.println("完成取数＝"+new Date(System.currentTimeMillis()));
        if(outJo.getBoolean("status")){
            JSONObject contentJo = outJo.getJSONObject("content");
            if(contentJo.getBoolean("success")){
                JSONArray dataJa = contentJo.getJSONArray("data");
                // 添加入库
                for(int a=0;a<dataJa.size();a++){
                    JSONObject dataJo = dataJa.getJSONObject(a);
                    System.out.println((a+1)+" "+dataJo);
                }
            }else{
                System.out.println("取数失败");
            }
        }else{
            System.out.println("取数失败");
        }
    }


    private String getToken(){
        JSONObject token = template.getForObject("http://127.0.0.1:9100/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
                JSONObject.class);
        return token.getString("accessToken");

    }

    @Override
    public String getRemoteToken() throws IOException {
//        JSONObject token = template.getForObject(apiIp + apiPort +"/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
//                JSONObject.class);
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("userId", "20210501");
        paramsMap.put("timestamp", "45546546454");
        paramsMap.put("random", "1156");
        paramsMap.put("sign", "7fa431325504e01e9fa87ed0e274c40c");

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);
        String url = apiIp + apiPort +"/token/getToken";
        //
        JSONObject outJo = httpClientUtil.get(url,paramsMap,timeoutMap);
        if(outJo.getBoolean("status")){
            return outJo.getJSONObject("content").getString("accessToken");
        }else{
            return outJo.getString("content");
        }
    }

    @Override
    public void getManyFarmStock() throws IOException {
        //
        String token = getRemoteToken();
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 120000);
        timeoutMap.put("requestTimeout", 120000);
        timeoutMap.put("socketTimeout", 120000);
        String url = apiIp + apiPort + serviceName +"/getManyFarmStock";
        log.info("获取多个牧场的存栏="+url);
        log.info("开始取数="+new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.get(url,paramsMap,timeoutMap);
        log.info("返回结果="+outJo);
        log.info("结束取数="+new Date(System.currentTimeMillis()));
        if(outJo.getBoolean("status")){
            JSONObject contentJo = outJo.getJSONObject("content");
            if(contentJo.getBoolean("success")){
                JSONArray dataJa = contentJo.getJSONArray("data");
                // 添加入库
                for(int a=0;a<dataJa.size();a++){
                    JSONObject dataJo = dataJa.getJSONObject(a);
                    System.out.println((a+1)+" "+dataJo);
                }
            }else{
                log.info("取数失败");
            }
        }else{
            log.info("取数失败");
        }
    }

    @Override
    public void getCostWithManyFarm() throws IOException {
        //
        String token = getRemoteToken();
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        paramsMap.put("year", dateUtil.getThisYear());
        paramsMap.put("month", dateUtil.getThisMonth());
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 120000);
        timeoutMap.put("requestTimeout", 120000);
        timeoutMap.put("socketTimeout", 120000);
        String url = apiIp + apiPort + serviceName +"/getCostWithManyFarm";
        log.info("获取多个牧场的成本="+url);
        log.info("开始取数="+new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.get(url,paramsMap,timeoutMap);
        log.info("返回结果="+outJo);
        log.info("结束取数="+new Date(System.currentTimeMillis()));
        if(outJo.getBoolean("status")){
            JSONObject contentJo = outJo.getJSONObject("content");
            if(contentJo.getBoolean("success")){
                JSONArray dataJa = contentJo.getJSONArray("data");
                if(dataJa.size()==0){
                    log.info("未取到数据 。");
                }
                // 添加入库
                for(int a=0;a<dataJa.size();a++){
                    JSONObject dataJo = dataJa.getJSONObject(a);
                    System.out.println((a+1)+" "+dataJo);
                }
            }else{
                System.out.println("取数失败");
            }
        }else{
            System.out.println("取数失败");
        }
    }

   /* public static void main(String[] args) {
        RestTemplate restTemplate = new RestTemplate();


        JSONObject token1 = restTemplate.getForObject("http://192.168.1.62:9100/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
                JSONObject.class);
       String token =  token1.getString("accessToken");
        JSONObject jsonObject = restTemplate.getForObject("http://192.168.1.62:9100/erpData/getReEstrusRate?startDate=2020.1.1&endDate=2021.12.31&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        String reestrus_rate ="0.00000";
       List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
            for (String s : stringStringMap.keySet()) {
                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    reestrus_rate  = stringStringMap.get("reestrus_rate");
                }
            }
        }



    }*/
}
