package com.huimv.production.autoGetData.utils;

import com.alibaba.fastjson.JSONObject;
import org.apache.http.*;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.*;
import org.apache.http.conn.routing.HttpRoute;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.impl.conn.PoolingHttpClientConnectionManager;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.*;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Component
public class HttpClientUtil {
    String httpIp = "http://121.40.221.149:9100";

    public static void main(String[] args) throws Exception {
        //
        HttpClientUtil client = new HttpClientUtil();
//        client.testGetRequest1();
        client.testGetRequest2();
    }

    private void testGetRequest1() throws IOException {
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);
        String url = httpIp + "/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c";
        // test error
        url = httpIp + "/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c&userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c";
        CloseableHttpClient httpClient = getHttpClientConnection();
        CloseableHttpResponse response = httpClient.execute(getHttpRequest(url, timeoutMap));
        // 打印响应状态
        System.out.println("响应状态1 =" + response.getStatusLine());
        try {
            if (response.getStatusLine().getStatusCode() == 200) {
                // 获取响应实体
                HttpEntity entity = response.getEntity();
                // 打印响应内容
                String text = EntityUtils.toString(entity, "utf-8");
                System.out.println("响应内容=" + text);

                JSONObject resultJo = JSONObject.parseObject(text);
                System.out.println("accessToken="+resultJo.getString("accessToken"));
            } else {
                System.out.println("请求失败");
            }
        } finally {
            response.close();
            httpClient.close();
        }
    }

    private void testGetRequest2() throws IOException {
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("userId", "20210501");
        paramsMap.put("timestamp", "45546546454");
        paramsMap.put("random", "1156");
        paramsMap.put("sign", "7fa431325504e01e9fa87ed0e274c40c");

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);

        String url = httpIp + "/token/getToken";
        //        get(url, paramsMap, timeoutMap);
        //
        JSONObject resultJo = get(url,paramsMap,timeoutMap);
        System.out.println("status="+resultJo.getBoolean("status"));
        System.out.println("content="+resultJo.getJSONObject("content"));
    }

    /**
     * @Method      : get
     * @Description : 
     * @Params      : [url, paramsMap, timeoutMap]
     * @Return      : com.alibaba.fastjson.JSONObject
     * 
     * @Author      : ZhuoNing
     * @Date        : 2021/11/18       
     * @Time        : 17:39
     */
    public JSONObject get(String url, Map<String, String> paramsMap, Map<String, Integer> timeoutMap) throws IOException {
        if(timeoutMap == null){
            timeoutMap.put("connectTimeout", 5000);
            timeoutMap.put("requestTimeout", 5000);
            timeoutMap.put("socketTimeout", 5000);
        }
        //
        CloseableHttpClient httpClient = getHttpClientConnection();
        //
        CloseableHttpResponse response = httpClient.execute(getHttpRequest(url, paramsMap, timeoutMap));
        try {
            // 打印响应状态
            if (response.getStatusLine().getStatusCode() == 200) {
                // 获取响应实体
                HttpEntity entity = response.getEntity();
                // 打印响应内容
                String text = EntityUtils.toString(entity, "utf-8");
                JSONObject resultJo = new JSONObject();
                resultJo.put("status",true);
                resultJo.put("content",text);
                return resultJo;
            } else {
                JSONObject resultJo = new JSONObject();
                resultJo.put("status",false);
                resultJo.put("content","请求失败");
                return resultJo;
            }
        } finally {
            response.close();
            httpClient.close();
        }

    }

    private CloseableHttpClient getHttpClientConnection() {
        CloseableHttpClient httpclient = HttpClients.createDefault();
//        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        return httpclient;
    }

    private HttpUriRequest getHttpRequest(String url, Map<String, String> map, Map<String, Integer> timeoutMap) {
        int connectTimeout = timeoutMap.get("connectTimeout");
        int requestTimeout = timeoutMap.get("requestTimeout");
        int socketTimeout = timeoutMap.get("socketTimeout");

        List<NameValuePair> params = new ArrayList<NameValuePair>();
        Set<Map.Entry<String, String>> entrySet = map.entrySet();
        for (Map.Entry<String, String> e : entrySet) {
            String name = e.getKey();
            String value = e.getValue();
            NameValuePair pair = new BasicNameValuePair(name, value);
            params.add(pair);
        }
        RequestConfig requestConfig = RequestConfig.custom()
                .setConnectTimeout(connectTimeout).setConnectionRequestTimeout(requestTimeout)
                .setSocketTimeout(socketTimeout).build();
        HttpUriRequest httpGet = RequestBuilder.get().setUri(url)
                .addParameters(params.toArray(new BasicNameValuePair[params.size()]))
                .setConfig(requestConfig).build();
        return httpGet;
    }

    private HttpGet getHttpRequest(String url, Map<String, Integer> timeoutMap) {
        int connectTimeout = timeoutMap.get("connectTimeout");
        int requestTimeout = timeoutMap.get("requestTimeout");
        int socketTimeout = timeoutMap.get("socketTimeout");

        HttpGet httpGet = new HttpGet(url);
        //设置超时时间
        RequestConfig requestConfig = RequestConfig.custom()
                .setConnectTimeout(connectTimeout).setConnectionRequestTimeout(requestTimeout)
                .setSocketTimeout(socketTimeout).build();
        httpGet.setConfig(requestConfig);
        return httpGet;
    }

    //test
    public void get() {
//        CloseableHttpClient httpclient = HttpClients.createDefault();
//        try {
//            // 创建httpget.
//            HttpGet httpget = new HttpGet(httpIp + "/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c");
//            System.out.println("executing request " + httpget.getURI());
//            // 执行get请求.
//            CloseableHttpResponse response = httpclient.execute(httpget);
//            try {
//                // 获取响应实体
//                HttpEntity entity = response.getEntity();
//                System.out.println("--------------------------------------");
//                // 打印响应状态
//                System.out.println(response.getStatusLine());
//                if (entity != null) {
//                    // 打印响应内容长度
//                    System.out.println("Response content length: " + entity.getContentLength());
//                    // 打印响应内容
//                    System.out.println("Response content: " + EntityUtils.toString(entity));
//                }
//                System.out.println("------------------------------------");
//            } finally {
//                response.close();
//            }
//        } catch (ClientProtocolException e) {
//            e.printStackTrace();
//        } catch (ParseException e) {
//            e.printStackTrace();
//        } catch (IOException e) {
//            e.printStackTrace();
//        } finally {
//            // 关闭连接,释放资源
//            try {
//                httpclient.close();
//            } catch (IOException e) {
//                e.printStackTrace();
//            }
//        }
    }


    private void getRequest() throws IOException {
//        //1.打开浏览器
//        CloseableHttpClient httpClient = HttpClients.createDefault();
//        //2.声明get请求
//        HttpGet httpGet = new HttpGet(httpIp + "/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c");
//        //3.发送请求
//        CloseableHttpResponse response = httpClient.execute(httpGet);
//        System.out.println("StatusCode=" + response.getStatusLine().getStatusCode());
//        //4.判断状态码
//        if (response.getStatusLine().getStatusCode() == 200) {
//            HttpEntity entity = response.getEntity();
//            //使用工具类EntityUtils，从响应中取出实体表示的内容并转换成字符串
//            String string = EntityUtils.toString(entity, "utf-8");
//            System.out.println(string);
//        }
//        //5.关闭资源
//        response.close();
//        httpClient.close();
    }
}
